function IsDaylightSavingTime(year, month, date) {
  year = parseInt(year)
  month = parseInt(month)
  date = parseInt(date)

  if(month < 3) return false
  if(month > 3 && month < 11) return true
  if(month > 11) return true

  if(month === 3) {
    return date >= March2ndSundayDate(year)
  }
  if(month === 11) {
    return date < November1stSundayDate(year)
  }
  return false
}

function March2ndSundayDate(year) {
  const march1st = new Date(year,2,1)
  const march1stDay = march1st.getDay()
  if(march1stDay === 0) return 8
  else {
    return 15 - march1stDay
  }
}

function November1stSundayDate(year) {
  const nov1st = new Date(year,10,1)
  const nov1stDay = nov1st.getDay()
  if(nov1stDay === 0) return 1
  else {
    return 8 - nov1stDay
  }
}

module.exports = {
  IsDaylightSavingTime
}


